// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.


// Implementation for heap
#include "heap.h"

// Test out the heap implementation -- with max heap
int main()
{
    // next
    cout << "Heap of ints being made." << endl;

    // randomly sorted array of ints:
    // step
    int C[5]{73, 6, 57, 88, 60};

    // heap(array, n, max) constructs the heap by reorganizing the array
    // skip the first time through, then run-again for trace
    heap<int> heap1(C, 5, 30);

    // add some items to the heap
    // step
    heap1.insert(100);
    heap1.insert(15);
    heap1.insert(4);

    // remove all the items from the heap in order
    // next
    cout << "\nPrinting heap in order: " << endl;

    // step
    while(heap1.size() > 0)
    {
        cout << heap1.removefirst() << endl;
    }

    return 0;
}
